<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use Carbon\Carbon;
use App\Http\Base\BaseModel;

class KapallokasiitemModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "kapallokasiitem";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "kapalLokasiItem";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "kapalId", "lokasiId", "date_updated", "lokasi", "alamatLokasi", "ORGCode"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [ 
        "namaLokasi" => "lokasiId.namaLokasi",
        "lokasi" => "kapalLokasiItem.lokasi",
        "kapal" => "kapalId.namaKapal"
    ];

    /**
     * relation from ' . administratorgroup . ' by ' . kapalId
     * join administratorgroup on administratorgroup.id = kapalLokasiItem.kapalId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationKapalId($alias = "kapalId")
    {
        $this->getQuery()->join("kapal as $alias", "$alias.id", "=", "kapalLokasiItem.kapalId");
        return $this;
    }

    /**
     * relation from ' . administratormenuacess . ' by ' . lokasiId
     * join administratormenuacess on administratormenuacess.id = kapalLokasiItem.lokasiId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationLokasiId($alias = "lokasiId")
    {
        $this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "kapalLokasiItem.lokasiId");
        return $this;
    }

    public static function storeFromHO($data)
    {
        $modelExist = (new self())->getQuery()->where("kapalLokasiItem.kapalId", "=", $data->kapalId)
            ->where("kapalLokasiItem.lokasiId", "=", $data->lokasiId)
            ->first();
        if ($modelExist) {
            $model = self::find($modelExist->id);
            $model->kapalId = $data->kapalId;
            $model->lokasiId = $data->lokasiId;
            $model->date_updated = $data->date_updated;
            $model->lokasi = $data->lokasi;
            $model->alamatLokasi = $data->alamatLokasi;
            $model->ORGCode = $data->ORGCode;
            $model->update();
            (new LogsynckapalModel)->setLogSync("Kapal-SubInventory - ".$data->kapalId." - ".$data->lokasiId, Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            $model = new self();
            $model->kapalId = $data->kapalId;
            $model->lokasiId = $data->lokasiId;
            $model->date_updated = $data->date_updated;
            $model->lokasi = $data->lokasi;
            $model->alamatLokasi = $data->alamatLokasi;
            $model->ORGCode = $data->ORGCode;
            $model->save([], $data->id, 0);
            (new LogsynckapalModel)->setLogSync("Kapal-SubInventory - ".$data->kapalId." - ".$data->lokasiId, Carbon::now()->toDateTimeString(), "", "inserted");
        }
        echo $data->kapalId . " sync", PHP_EOL;
    }

    public static function getKapalLokasiItem()
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_kapal_lokasiitem";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 16)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Kapal-SubInventory: HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {
                $syncHandler = new \App\Http\Handler\CurlHandler();
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $lastUpdate = !empty($syncTable->last_sync) ? \Carbon\Carbon::parse($syncTable->last_sync)->toAtomString() : $lastUpdate;
                $url = $url . "?date_updated=" . $lastUpdate . "&kapalId=" . $GLOBALS["env"]["KAPAL_ID"] . "&page=" . $page;
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        if($page == 1) {
                            \App\Http\Models\KapallokasiitemModel::truncate();
                        }
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\KapallokasiitemModel::storeFromHO($item);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find(16);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else $fetch = false;
                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Kapal-SubInventory: HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Kapal-SubInventory: HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }


    public static function storingDataKapalLokasiItem($lokasiId, $oracle) {
        $model = (new self())->getQuery()->where("kapalLokasiItem.kapalId", "=", $oracle->MTL_IO_ID)
        ->where("kapalLokasiItem.lokasiId", "=", $lokasiId)->first();
        if ($model) {
            try {
                $model = self::find($model->id);
                $model->lokasi = $oracle->DESCRIPTION;
                $model->ORGCode = $oracle->MTL_IO_CODE;
                $model->date_updated = $oracle->LAST_UPDATE_DATE;
                $model->update();
                (new LogsyncoracleModel)->setLogSync("Oracle-KapalSubInv : " . $oracle->MTL_IO_ID . "-" . $oracle->MTL_IO_CODE. " - " . $oracle->DESCRIPTION, Carbon::now()->toDateTimeString(), "","updated");
            } catch (\Exception $exception) {
                echo $exception->getMessage(), PHP_EOL;
            }
        } else {
            try {
                $model = new self();
                $model->lokasiId = $lokasiId;
                $model->kapalId = $oracle->MTL_IO_ID;
                $model->lokasi = $oracle->DESCRIPTION;
                $model->ORGCode = $oracle->MTL_IO_CODE;
                $model->date_updated = $oracle->LAST_UPDATE_DATE;
                $model->save();
                (new LogsyncoracleModel)->setLogSync("Oracle-KapalSubInv :" . $oracle->MTL_IO_ID . "-" . $oracle->MTL_IO_CODE. " - " . $oracle->DESCRIPTION, Carbon::now()->toDateTimeString(), "","inserted");
            } catch (\Exception $exception) {
                // FUNCTION TO INSERT INTO SYNCERROR TABLE IN CASE THE PROCESS ABOVE HAS SOME ERROR
                $params = json_encode([
                    "SUBINV_CODE" => $oracle->SUBINV_CODE,
                    "MTL_IO_ID" => $oracle->MTL_IO_ID
                ]);
                $data = json_encode($oracle);
                (new SyncerrorModel)->saveError("pelni_scm_subinv_v", $params, $data, "HO");
                echo $exception->getMessage(), PHP_EOL;
            }
        }
        echo $oracle->DESCRIPTION . " sync", PHP_EOL;
    }
}